import java.util.*;
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

public class LightWallet extends MIDlet implements CommandListener {
    private static final int APP_STARTED   = 0;
    private static final int APP_ACTIVE    = 1;
    private static final int APP_DESTROYED = 2;

    private static final Command CMD_OK                = new Command("OK",           Command.OK,     1);
    private static final Command CMD_CANCEL            = new Command("Cancel",       Command.CANCEL, 1);
    private static final Command CMD_BACK              = new Command("Back",         Command.BACK,   1);
    private static final Command CMD_SELECT            = new Command("Select",       Command.ITEM,   1);
    private static final Command CMD_SAVE              = new Command("Save",         Command.SCREEN, 1);
    private static final Command CMD_REFRESH           = new Command("Refresh",      Command.SCREEN, 1);

    private static final Command CMD_ADD               = new Command("Add",          Command.ITEM,   2);
    private static final Command CMD_EDIT              = new Command("Edit",         Command.ITEM,   2);
    private static final Command CMD_DELETE            = new Command("Delete",       Command.ITEM,   2);
    private static final Command CMD_TRANSFER          = new Command("Transfer",     Command.ITEM,   2);
    private static final Command CMD_SWVIEW            = new Command("Switch View",  Command.SCREEN, 2);
    private static final Command CMD_FILTER            = new Command("Filter",       Command.SCREEN, 2);
    private static final Command CMD_STATISTICS        = new Command("Statistics",   Command.SCREEN, 2);
    private static final Command CMD_STAT_PER_CATEGORY = new Command("Per Category", Command.SCREEN, 2);
    private static final Command CMD_STAT_PER_DAY      = new Command("Per Day",      Command.SCREEN, 2);
    private static final Command CMD_OPTIONS           = new Command("Options",      Command.SCREEN, 2);
    private static final Command CMD_CLRMONTH          = new Command("Clear Month",  Command.SCREEN, 2);
    private static final Command CMD_EXPORT            = new Command("Export Data",  Command.SCREEN, 2);
    private static final Command CMD_IMPORT            = new Command("Import Data",  Command.SCREEN, 2);
    private static final Command CMD_HELP              = new Command("Help",         Command.SCREEN, 2);
    private static final Command CMD_ABOUT             = new Command("About",        Command.SCREEN, 2);
    private static final Command CMD_EXIT              = new Command("Exit",         Command.EXIT,   2);

    private static final String BIG_APPLICATION_ICON          = "/icons/icon-big.png";
    private static final String OPTION_WALLETS_ICON           = "/icons/wallet.png";
    private static final String OPTION_CATEGORIES_ICON        = "/icons/category.png";
    private static final String OPTION_SETTINGS_ICON          = "/icons/settings.png";
    private static final String EXPORT_CSV_ICON               = "/icons/csv.png";
    private static final String EXPORT_GDOCS_ICON             = "/icons/gdocs.png";
    private static final String IMPORT_CSV_ICON               = "/icons/csv.png";
    private static final String IMPORT_GDOCS_ICON             = "/icons/gdocs.png";

    private static final String OPTION_NAMES[]                = {"Wallets", "Categories", "Settings"};
    private static final int    OPTION_WALLETS                = 0;
    private static final int    OPTION_CATEGORIES             = 1;
    private static final int    OPTION_SETTINGS               = 2;

    private static final String DECIMAL_SEPARATORS[]          = {".", ","};
    private static final int    DECIMAL_SEPARATOR_DOT         = 0;
    private static final int    DECIMAL_SEPARATOR_COMMA       = 1;

    private static final String TRANSACTION_TYPES[]           = {"Charge", "Income"};
    private static final int    TRANSACTION_TYPE_CHARGE       = 0;
    private static final int    TRANSACTION_TYPE_INCOME       = 1;

    private static final String DATE_FILTER_TYPES[]           = {"All", "Specified Date"};
    private static final int    DATE_FILTER_TYPE_ALL          = 0;
    private static final int    DATE_FILTER_TYPE_SPEC_DATE    = 1;

    private static final String EXPORT_DSTS[]                 = {"CSV File", "Google Spreadsheet"};
    private static final int    EXPORT_DST_CSV                = 0;
    private static final int    EXPORT_DST_GDOCS              = 1;

    private static final String IMPORT_SRCS[]                 = {"CSV File", "Google Spreadsheet"};
    private static final int    IMPORT_SRC_CSV                = 0;
    private static final int    IMPORT_SRC_GDOCS              = 1;

    private static final String EXPORT_WALLETS[]              = {"All Wallets", "Selected Wallet"};
    private static final int    EXPORT_WALLET_ALL             = 0;
    private static final int    EXPORT_WALLET_SELECTED        = 1;

    private static final String EXPORT_PERIODS[]              = {"All Months", "Selected Month"};
    private static final int    EXPORT_PERIOD_ALL             = 0;
    private static final int    EXPORT_PERIOD_SELECTED_MONTH  = 1;

    private static final String CSV_DELIMITERS[]              = {",", ";"};
    private static final int    CSV_DELIMITER_COMMA           = 0;
    private static final int    CSV_DELIMITER_SEMICOLON       = 1;

    private int AppState = APP_STARTED,
                CurrentWalletId = 0,
                CurrentCategoryFilterId = 0,
                CurrentDateFilterType = DATE_FILTER_TYPE_ALL,
                CurrentViewType = WalletTransactionsTableClass.VIEW_CATEGORIES,
                AddTransactionFormCategoryIds[],
                EditTransactionFormCategoryIds[],
                TransferFormWalletIds[],
                TransferFormCategoryIds[],
                FilterTransactionsFormCategoryIds[],
                WalletsListIds[],
                CategoriesListIds[],
                SelectInitialBalanceCategoryFormCategoryIds[];

    private String CurrentWalletName = "";

    private Calendar CurrentMonth      = Calendar.getInstance(),
                     CurrentDateFilter = Calendar.getInstance();

    private Thread BgOperationThread = null;

    private Displayable                                  LastDisplayable = null;
    private Alert                                        InitErrorAlert = null,
                                                         ProgressAlert = null,
                                                         CSVProgressAlert = null,
                                                         GDocsProgressAlert = null;
    private List                                         OptionsList = null,
                                                         WalletsList = null,
                                                         CategoriesList = null,
                                                         ExportList = null,
                                                         ImportList = null;
    private Form                                         AboutForm = null,
                                                         HelpForm = null,
                                                         AddTransactionForm = null,
                                                         EditTransactionForm = null,
                                                         TransferForm = null,
                                                         DeleteTransactionForm = null,
                                                         FilterTransactionsForm = null,
                                                         AddWalletForm = null,
                                                         EditWalletForm = null,
                                                         DeleteWalletForm = null,
                                                         AddCategoryForm = null,
                                                         EditCategoryForm = null,
                                                         DeleteCategoryForm = null,
                                                         SettingsForm = null,
                                                         ClearMonthForm = null,
                                                         CSVExportForm = null,
                                                         GDocsExportForm = null,
                                                         CSVImportForm = null,
                                                         GDocsImportForm,
                                                         CreateInitialBalancesForm = null,
                                                         SelectInitialBalanceCategoryForm = null;
    private TextField                                    AddTransactionTransactionAmountTextField = null,
                                                         AddTransactionTransactionCommentTextField = null,
                                                         EditTransactionTransactionAmountTextField = null,
                                                         EditTransactionTransactionCommentTextField = null,
                                                         TransferTransactionAmountTextField = null,
                                                         AddWalletWalletNameTextField = null,
                                                         EditWalletWalletNameTextField = null,
                                                         AddCategoryCategoryNameTextField = null,
                                                         EditCategoryCategoryNameTextField = null,
                                                         CSVExportFileNameTextField = null,
                                                         GDocsExportAccountNameTextField = null,
                                                         GDocsExportAccountPassTextField = null,
                                                         GDocsExportSpreadsheetNameTextField = null,
                                                         CSVImportFileNameTextField = null,
                                                         GDocsImportAccountNameTextField = null,
                                                         GDocsImportAccountPassTextField = null,
                                                         GDocsImportSpreadsheetNameTextField = null;
    private DateField                                    AddTransactionTransactionDateDateField = null,
                                                         EditTransactionTransactionDateDateField = null,
                                                         TransferTransactionDateDateField = null,
                                                         FilterTransactionsDateFilterDateField = null;
    private ChoiceGroup                                  AddTransactionTypeChoiceGroup = null,
                                                         AddTransactionCategoryChoiceGroup = null,
                                                         EditTransactionTypeChoiceGroup = null,
                                                         EditTransactionCategoryChoiceGroup = null,
                                                         TransferDestinationWalletChoiceGroup = null,
                                                         TransferChargeCategoryChoiceGroup = null,
                                                         TransferIncomeCategoryChoiceGroup = null,
                                                         FilterTransactionsCategoryChoiceGroup = null,
                                                         FilterTransactionsDateFilterTypeChoiceGroup = null,
                                                         SettingsDecimalSeparatorChoiceGroup = null,
                                                         CSVExportWalletChoiceGroup = null,
                                                         CSVExportPeriodChoiceGroup = null,
                                                         CSVExportDelimiterChoiceGroup = null,
                                                         CSVExportFSRootChoiceGroup = null,
                                                         GDocsExportWalletChoiceGroup = null,
                                                         GDocsExportPeriodChoiceGroup = null,
                                                         CSVImportDelimiterChoiceGroup = null,
                                                         CSVImportFSRootChoiceGroup = null,
                                                         SelectInitialBalanceCategoryCategoryChoiceGroup = null;
    private WalletBalanceTableClass                      WalletBalanceTable = null;
    private WalletTransactionsTableClass                 WalletTransactionsTable = null;
    private WalletTotalsPerCategoryStatisticsTableClass  WalletTotalsPerCategoryStatisticsTable = null;
    private WalletChargeIncomePerDayStatisticsTableClass WalletChargeIncomePerDayStatisticsTable = null;

    private void ShowInitErrorMessage(String text) {
        InitErrorAlert = new Alert("Application Initialization Error", text, null, AlertType.ALARM);

        InitErrorAlert.setTimeout(Alert.FOREVER);
        InitErrorAlert.addCommand(CMD_EXIT);
        InitErrorAlert.setCommandListener(this);

        Display.getDisplay(this).setCurrent(InitErrorAlert);
    }

    private void ShowErrorMessage(String text) {
        Alert alert = new Alert("Error", text, null, AlertType.ERROR);
        alert.setTimeout(Alert.FOREVER);

        Display.getDisplay(this).setCurrent(alert, Display.getDisplay(this).getCurrent());
    }

    private void ShowErrorMessage(String text, Displayable next) {
        Alert alert = new Alert("Error", text, null, AlertType.ERROR);
        alert.setTimeout(Alert.FOREVER);

        Display.getDisplay(this).setCurrent(alert, next);
    }

    private void ShowInfoMessage(String text, Displayable next) {
        Alert alert = new Alert("Info", text, null, AlertType.INFO);
        alert.setTimeout(Alert.FOREVER);

        Display.getDisplay(this).setCurrent(alert, next);
    }

    private void ShowProgressMessage(String text) {
        ProgressAlert = new Alert("Operation In Progress", text, null, AlertType.INFO);

        ProgressAlert.setTimeout(Alert.FOREVER);
        ProgressAlert.addCommand(CMD_REFRESH);
        ProgressAlert.setCommandListener(this);

        Display.getDisplay(this).setCurrent(ProgressAlert);
    }

    private void ShowCSVProgressMessage(String text) {
        CSVProgressAlert = new Alert("Operation In Progress", text, null, AlertType.INFO);

        CSVProgressAlert.setTimeout(Alert.FOREVER);
        CSVProgressAlert.addCommand(CMD_CANCEL);
        CSVProgressAlert.setCommandListener(this);

        Display.getDisplay(this).setCurrent(CSVProgressAlert);
    }

    private void ShowGDocsProgressMessage(String text) {
        GDocsProgressAlert = new Alert("Operation In Progress", text, null, AlertType.INFO);

        GDocsProgressAlert.setTimeout(Alert.FOREVER);
        GDocsProgressAlert.addCommand(CMD_CANCEL);
        GDocsProgressAlert.setCommandListener(this);

        Display.getDisplay(this).setCurrent(GDocsProgressAlert);
    }

    private void ShowAboutForm() {
        String version = getAppProperty("MIDlet-Version");
        String vendor  = getAppProperty("MIDlet-Vendor");
        String url     = getAppProperty("MIDlet-Info-URL");
        String csv_ops;

        if (version == null) {
            version = "Unknown version";
        }
        if (vendor == null) {
            vendor = "Unknown vendor";
        }
        if (url == null) {
            url = "Unknown info URL";
        }
        if (UtilClass.ValidateFileConnectionAPI()) {
            csv_ops = "CSV Import/Export: available";
        } else {
            csv_ops = "CSV Import/Export: not available";
        }

        AboutForm = new Form("About");
        try {
            ImageItem icon = new ImageItem(null, Image.createImage(BIG_APPLICATION_ICON),
                                           Item.LAYOUT_CENTER | Item.LAYOUT_NEWLINE_AFTER, null);

            AboutForm.append(icon);
        } catch (Exception ex) {
            // Ignore
        }
        AboutForm.append("\n" + "LightWallet Version " + version + "\n\n" + "Developer: " + vendor + "\n\n" + url + "\n\n" + csv_ops);
        AboutForm.addCommand(CMD_BACK);
        AboutForm.setCommandListener(this);

        Display.getDisplay(this).setCurrent(AboutForm);
    }

    private void ShowHelpForm() {
        String url = getAppProperty("MIDlet-Info-URL");

        if (url == null) {
            url = "Unknown info URL";
        }

        HelpForm = new Form("Help");
        HelpForm.append("LightWallet is a open source lightweight J2ME personal finance management application for mobile phones." + "\n\n" +
                        "If you have any questions regarding this application, you can contact application developer on this website:" + "\n\n" +
                        url);
        HelpForm.addCommand(CMD_BACK);
        HelpForm.setCommandListener(this);

        Display.getDisplay(this).setCurrent(HelpForm);
    }

    private void ShowWalletBalanceTable() {
        WalletBalanceTable = new WalletBalanceTableClass(CurrentMonth);

        WalletBalanceTable.addCommand(CMD_SELECT);
        WalletBalanceTable.addCommand(CMD_OPTIONS);
        WalletBalanceTable.addCommand(CMD_CLRMONTH);
        WalletBalanceTable.addCommand(CMD_EXPORT);
        WalletBalanceTable.addCommand(CMD_IMPORT);
        WalletBalanceTable.addCommand(CMD_HELP);
        WalletBalanceTable.addCommand(CMD_ABOUT);
        WalletBalanceTable.addCommand(CMD_EXIT);
        WalletBalanceTable.setCommandListener(this);

        Display.getDisplay(this).setCurrent(WalletBalanceTable);
    }

    private void ShowWalletTransactionsTable() {
        WalletTransactionsTable = new WalletTransactionsTableClass(CurrentMonth, CurrentWalletId, CurrentCategoryFilterId,
                                                                   CurrentDateFilterType == DATE_FILTER_TYPE_SPEC_DATE ?
                                                                                            CurrentDateFilter : null,
                                                                   CurrentViewType, CurrentWalletName);

        WalletTransactionsTable.addCommand(CMD_ADD);
        WalletTransactionsTable.addCommand(CMD_EDIT);
        WalletTransactionsTable.addCommand(CMD_DELETE);
        WalletTransactionsTable.addCommand(CMD_TRANSFER);
        WalletTransactionsTable.addCommand(CMD_SWVIEW);
        WalletTransactionsTable.addCommand(CMD_FILTER);
        WalletTransactionsTable.addCommand(CMD_STATISTICS);
        WalletTransactionsTable.addCommand(CMD_OPTIONS);
        WalletTransactionsTable.addCommand(CMD_EXIT);
        WalletTransactionsTable.addCommand(CMD_BACK);
        WalletTransactionsTable.setCommandListener(this);

        Display.getDisplay(this).setCurrent(WalletTransactionsTable);
    }

    private void ShowWalletTotalsPerCategoryStatisticsTable() {
        WalletTotalsPerCategoryStatisticsTable = new WalletTotalsPerCategoryStatisticsTableClass(CurrentMonth, CurrentWalletId, CurrentWalletName);

        WalletTotalsPerCategoryStatisticsTable.addCommand(CMD_STAT_PER_DAY);
        WalletTotalsPerCategoryStatisticsTable.addCommand(CMD_BACK);
        WalletTotalsPerCategoryStatisticsTable.setCommandListener(this);

        Display.getDisplay(this).setCurrent(WalletTotalsPerCategoryStatisticsTable);
    }

    private void ShowWalletChargeIncomePerDayStatisticsTable() {
        WalletChargeIncomePerDayStatisticsTable = new WalletChargeIncomePerDayStatisticsTableClass(CurrentMonth, CurrentWalletId, CurrentWalletName);

        WalletChargeIncomePerDayStatisticsTable.addCommand(CMD_STAT_PER_CATEGORY);
        WalletChargeIncomePerDayStatisticsTable.addCommand(CMD_BACK);
        WalletChargeIncomePerDayStatisticsTable.setCommandListener(this);

        Display.getDisplay(this).setCurrent(WalletChargeIncomePerDayStatisticsTable);
    }

    private void ShowAddTransactionForm() {
        String category_names[];
        Vector categories;

        try {
            categories = CategoryStorageClass.GetListSortedByName();

            AddTransactionFormCategoryIds = new int[categories.size()];
            category_names                = new String[categories.size()];

            for (int i = 0; i < categories.size(); i++) {
                AddTransactionFormCategoryIds[i] = ((CategoryClass)categories.elementAt(i)).GetId();
                category_names[i]                = ((CategoryClass)categories.elementAt(i)).GetName();
            }

            AddTransactionTransactionDateDateField    = new DateField("Date", DateField.DATE_TIME);
            AddTransactionTypeChoiceGroup             = new ChoiceGroup("Type", ChoiceGroup.POPUP, TRANSACTION_TYPES, null);
            AddTransactionTransactionAmountTextField  = new TextField("Amount", "", 128, TextField.ANY);
            AddTransactionCategoryChoiceGroup         = new ChoiceGroup("Category", ChoiceGroup.POPUP, category_names, null);
            AddTransactionTransactionCommentTextField = new TextField("Comment", "", 64, TextField.ANY);

            AddTransactionTransactionDateDateField.setDate(new Date());
            AddTransactionTransactionAmountTextField.setInitialInputMode("IS_LATIN_DIGITS");

            AddTransactionForm = new Form("Add New Transaction");
            AddTransactionForm.append(AddTransactionTransactionDateDateField);
            AddTransactionForm.append(AddTransactionTypeChoiceGroup);
            AddTransactionForm.append(AddTransactionTransactionAmountTextField);
            AddTransactionForm.append(AddTransactionCategoryChoiceGroup);
            AddTransactionForm.append(AddTransactionTransactionCommentTextField);
            AddTransactionForm.addCommand(CMD_SAVE);
            AddTransactionForm.addCommand(CMD_BACK);
            AddTransactionForm.setCommandListener(this);

            Display.getDisplay(this).setCurrent(AddTransactionForm);
        } catch (Exception ex) {
            ShowErrorMessage(ex.toString());
        }
    }

    private void ShowEditTransactionForm(TransactionClass transaction) {
        int    selected_category = 0;
        String category_names[];
        Vector categories;

        try {
            categories = CategoryStorageClass.GetListSortedByName();

            EditTransactionFormCategoryIds = new int[categories.size()];
            category_names                 = new String[categories.size()];

            for (int i = 0; i < categories.size(); i++) {
                EditTransactionFormCategoryIds[i] = ((CategoryClass)categories.elementAt(i)).GetId();
                category_names[i]                 = ((CategoryClass)categories.elementAt(i)).GetName();

                if (transaction.GetCategoryId() == ((CategoryClass)categories.elementAt(i)).GetId()) {
                    selected_category = i;
                }
            }

            long amount = transaction.GetAmount();

            if (amount < 0) {
                amount = -amount;
            }

            EditTransactionTransactionDateDateField    = new DateField("Date", DateField.DATE_TIME);
            EditTransactionTypeChoiceGroup             = new ChoiceGroup("Type", ChoiceGroup.POPUP, TRANSACTION_TYPES, null);
            EditTransactionTransactionAmountTextField  = new TextField("Amount", UtilClass.MoneyToString(amount), 128, TextField.ANY);
            EditTransactionCategoryChoiceGroup         = new ChoiceGroup("Category", ChoiceGroup.POPUP, category_names, null);
            EditTransactionTransactionCommentTextField = new TextField("Comment", transaction.GetComment(), 64, TextField.ANY);

            EditTransactionTransactionDateDateField.setDate(transaction.GetDate());
            if (transaction.GetAmount() > 0) {
                EditTransactionTypeChoiceGroup.setSelectedIndex(TRANSACTION_TYPE_INCOME, true);
            } else {
                EditTransactionTypeChoiceGroup.setSelectedIndex(TRANSACTION_TYPE_CHARGE, true);
            }
            EditTransactionTransactionAmountTextField.setInitialInputMode("IS_LATIN_DIGITS");
            EditTransactionCategoryChoiceGroup.setSelectedIndex(selected_category, true);

            EditTransactionForm = new Form("Edit Transaction");
            EditTransactionForm.append(EditTransactionTransactionDateDateField);
            EditTransactionForm.append(EditTransactionTypeChoiceGroup);
            EditTransactionForm.append(EditTransactionTransactionAmountTextField);
            EditTransactionForm.append(EditTransactionCategoryChoiceGroup);
            EditTransactionForm.append(EditTransactionTransactionCommentTextField);
            EditTransactionForm.addCommand(CMD_SAVE);
            EditTransactionForm.addCommand(CMD_BACK);
            EditTransactionForm.setCommandListener(this);

            Display.getDisplay(this).setCurrent(EditTransactionForm);
        } catch (Exception ex) {
            ShowErrorMessage(ex.toString());
        }
    }

    private void ShowDeleteTransactionForm(String header, String text) {
        DeleteTransactionForm = new Form(header);
        DeleteTransactionForm.append(text);
        DeleteTransactionForm.addCommand(CMD_OK);
        DeleteTransactionForm.addCommand(CMD_CANCEL);
        DeleteTransactionForm.setCommandListener(this);

        Display.getDisplay(this).setCurrent(DeleteTransactionForm);
    }

    private void ShowTransferForm() {
        int    selected_charge_category = 0,
               selected_income_category = 0;
        String wallet_names[],
               category_names[];
        Vector wallets,
               categories;

        try {
            wallets = WalletStorageClass.GetListSortedByName();

            TransferFormWalletIds = new int[wallets.size()];
            wallet_names          = new String[wallets.size()];

            for (int i = 0; i < wallets.size(); i++) {
                TransferFormWalletIds[i] = ((WalletClass)wallets.elementAt(i)).GetId();
                wallet_names[i]          = ((WalletClass)wallets.elementAt(i)).GetName();
            }

            categories = CategoryStorageClass.GetListSortedByName();

            TransferFormCategoryIds = new int[categories.size()];
            category_names          = new String[categories.size()];

            for (int i = 0; i < categories.size(); i++) {
                TransferFormCategoryIds[i] = ((CategoryClass)categories.elementAt(i)).GetId();
                category_names[i]          = ((CategoryClass)categories.elementAt(i)).GetName();

                if (SettingStorageClass.GetTransferChargeCategoryId() == ((CategoryClass)categories.elementAt(i)).GetId()) {
                    selected_charge_category = i;
                }
                if (SettingStorageClass.GetTransferIncomeCategoryId() == ((CategoryClass)categories.elementAt(i)).GetId()) {
                    selected_income_category = i;
                }
            }

            TransferTransactionDateDateField     = new DateField("Date", DateField.DATE_TIME);
            TransferTransactionAmountTextField   = new TextField("Amount", "", 128, TextField.ANY);
            TransferDestinationWalletChoiceGroup = new ChoiceGroup("Destination Wallet", ChoiceGroup.POPUP, wallet_names, null);
            TransferChargeCategoryChoiceGroup    = new ChoiceGroup("Charge Category", ChoiceGroup.POPUP, category_names, null);
            TransferIncomeCategoryChoiceGroup    = new ChoiceGroup("Income Category", ChoiceGroup.POPUP, category_names, null);

            TransferTransactionDateDateField.setDate(new Date());
            TransferTransactionAmountTextField.setInitialInputMode("IS_LATIN_DIGITS");
            TransferChargeCategoryChoiceGroup.setSelectedIndex(selected_charge_category, true);
            TransferIncomeCategoryChoiceGroup.setSelectedIndex(selected_income_category, true);

            TransferForm = new Form("Transfer Money");
            TransferForm.append(TransferTransactionDateDateField);
            TransferForm.append(TransferTransactionAmountTextField);
            TransferForm.append(TransferDestinationWalletChoiceGroup);
            TransferForm.append(TransferChargeCategoryChoiceGroup);
            TransferForm.append(TransferIncomeCategoryChoiceGroup);
            TransferForm.addCommand(CMD_OK);
            TransferForm.addCommand(CMD_BACK);
            TransferForm.setCommandListener(this);

            Display.getDisplay(this).setCurrent(TransferForm);
        } catch (Exception ex) {
            ShowErrorMessage(ex.toString());
        }
    }

    private void ShowFilterTransactionsForm() {
        int    selected_category = 0;
        String category_names[];
        Vector categories;

        try {
            categories = CategoryStorageClass.GetListSortedByName();

            FilterTransactionsFormCategoryIds = new int[categories.size() + 1];
            category_names                    = new String[categories.size() + 1];

            FilterTransactionsFormCategoryIds[0] = 0;
            category_names[0]                    = "[All]";

            for (int i = 0; i < categories.size(); i++) {
                FilterTransactionsFormCategoryIds[i + 1] = ((CategoryClass)categories.elementAt(i)).GetId();
                category_names[i + 1]                    = ((CategoryClass)categories.elementAt(i)).GetName();

                if (CurrentCategoryFilterId == ((CategoryClass)categories.elementAt(i)).GetId()) {
                    selected_category = i + 1;
                }
            }

            FilterTransactionsCategoryChoiceGroup       = new ChoiceGroup("By Category", ChoiceGroup.POPUP, category_names, null);
            FilterTransactionsDateFilterTypeChoiceGroup = new ChoiceGroup("By Date", ChoiceGroup.POPUP, DATE_FILTER_TYPES, null);
            FilterTransactionsDateFilterDateField       = new DateField("Date", DateField.DATE);

            FilterTransactionsCategoryChoiceGroup.setSelectedIndex(selected_category, true);
            FilterTransactionsDateFilterTypeChoiceGroup.setSelectedIndex(CurrentDateFilterType, true);
            FilterTransactionsDateFilterDateField.setDate(CurrentDateFilter.getTime());

            FilterTransactionsForm = new Form("Filter Transactions");
            FilterTransactionsForm.append(FilterTransactionsCategoryChoiceGroup);
            FilterTransactionsForm.append(FilterTransactionsDateFilterTypeChoiceGroup);
            FilterTransactionsForm.append(FilterTransactionsDateFilterDateField);
            FilterTransactionsForm.addCommand(CMD_OK);
            FilterTransactionsForm.addCommand(CMD_BACK);
            FilterTransactionsForm.setCommandListener(this);

            Display.getDisplay(this).setCurrent(FilterTransactionsForm);
        } catch (Exception ex) {
            ShowErrorMessage(ex.toString());
        }
    }

    private void ShowOptionsList() {
        Image option_icons[];

        try {
            option_icons = new Image[3];

            option_icons[0] = Image.createImage(OPTION_WALLETS_ICON);
            option_icons[1] = Image.createImage(OPTION_CATEGORIES_ICON);
            option_icons[2] = Image.createImage(OPTION_SETTINGS_ICON);
        } catch (Exception ex) {
            option_icons = null;
        }

        OptionsList = new List("Options", Choice.IMPLICIT, OPTION_NAMES, option_icons);
        OptionsList.addCommand(CMD_SELECT);
        OptionsList.addCommand(CMD_BACK);
        OptionsList.setSelectCommand(CMD_SELECT);
        OptionsList.setCommandListener(this);

        Display.getDisplay(this).setCurrent(OptionsList);
    }

    private void ShowWalletsList() {
        String wallet_names[];
        Vector wallets;

        try {
            wallets = WalletStorageClass.GetListSortedByName();

            WalletsListIds = new int[wallets.size()];
            wallet_names   = new String[wallets.size()];

            for (int i = 0; i < wallets.size(); i++) {
                WalletsListIds[i] = ((WalletClass)wallets.elementAt(i)).GetId();
                wallet_names[i]   = ((WalletClass)wallets.elementAt(i)).GetName();
            }

            WalletsList = new List("Wallets", Choice.IMPLICIT, wallet_names, null);
            WalletsList.addCommand(CMD_ADD);
            WalletsList.addCommand(CMD_EDIT);
            WalletsList.addCommand(CMD_DELETE);
            WalletsList.addCommand(CMD_BACK);
            WalletsList.setSelectCommand(CMD_EDIT);
            WalletsList.setCommandListener(this);

            Display.getDisplay(this).setCurrent(WalletsList);
        } catch (Exception ex) {
            ShowErrorMessage(ex.toString());
        }
    }

    private void ShowAddWalletForm() {
        AddWalletWalletNameTextField = new TextField("Wallet Name", "", 32, TextField.ANY);

        AddWalletForm = new Form("Add New Wallet");
        AddWalletForm.append(AddWalletWalletNameTextField);
        AddWalletForm.addCommand(CMD_SAVE);
        AddWalletForm.addCommand(CMD_BACK);
        AddWalletForm.setCommandListener(this);

        Display.getDisplay(this).setCurrent(AddWalletForm);
    }

    private void ShowEditWalletForm(WalletClass wallet) {
        EditWalletWalletNameTextField = new TextField("Wallet Name", wallet.GetName(), 32, TextField.ANY);

        EditWalletForm = new Form("Edit Wallet");
        EditWalletForm.append(EditWalletWalletNameTextField);
        EditWalletForm.addCommand(CMD_SAVE);
        EditWalletForm.addCommand(CMD_BACK);
        EditWalletForm.setCommandListener(this);

        Display.getDisplay(this).setCurrent(EditWalletForm);
    }

    private void ShowDeleteWalletForm(String header, String text) {
        DeleteWalletForm = new Form(header);
        DeleteWalletForm.append(text);
        DeleteWalletForm.addCommand(CMD_OK);
        DeleteWalletForm.addCommand(CMD_CANCEL);
        DeleteWalletForm.setCommandListener(this);

        Display.getDisplay(this).setCurrent(DeleteWalletForm);
    }

    private void ShowCategoriesList() {
        String category_names[];
        Vector categories;

        try {
            categories = CategoryStorageClass.GetListSortedByName();

            CategoriesListIds = new int[categories.size()];
            category_names    = new String[categories.size()];

            for (int i = 0; i < categories.size(); i++) {
                CategoriesListIds[i] = ((CategoryClass)categories.elementAt(i)).GetId();
                category_names[i]    = ((CategoryClass)categories.elementAt(i)).GetName();
            }

            CategoriesList = new List("Categories", Choice.IMPLICIT, category_names, null);
            CategoriesList.addCommand(CMD_ADD);
            CategoriesList.addCommand(CMD_EDIT);
            CategoriesList.addCommand(CMD_DELETE);
            CategoriesList.addCommand(CMD_BACK);
            CategoriesList.setSelectCommand(CMD_EDIT);
            CategoriesList.setCommandListener(this);

            Display.getDisplay(this).setCurrent(CategoriesList);
        } catch (Exception ex) {
            ShowErrorMessage(ex.toString());
        }
    }

    private void ShowAddCategoryForm() {
        AddCategoryCategoryNameTextField = new TextField("Category Name", "", 32, TextField.ANY);

        AddCategoryForm = new Form("Add New Category");
        AddCategoryForm.append(AddCategoryCategoryNameTextField);
        AddCategoryForm.addCommand(CMD_SAVE);
        AddCategoryForm.addCommand(CMD_BACK);
        AddCategoryForm.setCommandListener(this);

        Display.getDisplay(this).setCurrent(AddCategoryForm);
    }

    private void ShowEditCategoryForm(CategoryClass category) {
        EditCategoryCategoryNameTextField = new TextField("Category Name", category.GetName(), 32, TextField.ANY);

        EditCategoryForm = new Form("Edit Category");
        EditCategoryForm.append(EditCategoryCategoryNameTextField);
        EditCategoryForm.addCommand(CMD_SAVE);
        EditCategoryForm.addCommand(CMD_BACK);
        EditCategoryForm.setCommandListener(this);

        Display.getDisplay(this).setCurrent(EditCategoryForm);
    }

    private void ShowDeleteCategoryForm(String header, String text) {
        DeleteCategoryForm = new Form(header);
        DeleteCategoryForm.append(text);
        DeleteCategoryForm.addCommand(CMD_OK);
        DeleteCategoryForm.addCommand(CMD_CANCEL);
        DeleteCategoryForm.setCommandListener(this);

        Display.getDisplay(this).setCurrent(DeleteCategoryForm);
    }

    private void ShowSettingsForm() {
        SettingsDecimalSeparatorChoiceGroup = new ChoiceGroup("Decimal Separator", ChoiceGroup.POPUP, DECIMAL_SEPARATORS, null);

        if (SettingStorageClass.GetDecimalSeparator().equals(".")) {
            SettingsDecimalSeparatorChoiceGroup.setSelectedIndex(DECIMAL_SEPARATOR_DOT, true);
        } else if (SettingStorageClass.GetDecimalSeparator().equals(",")) {
            SettingsDecimalSeparatorChoiceGroup.setSelectedIndex(DECIMAL_SEPARATOR_COMMA, true);
        }

        SettingsForm = new Form("Settings");
        SettingsForm.append(SettingsDecimalSeparatorChoiceGroup);
        SettingsForm.addCommand(CMD_SAVE);
        SettingsForm.addCommand(CMD_BACK);
        SettingsForm.setCommandListener(this);

        Display.getDisplay(this).setCurrent(SettingsForm);
    }

    private void ShowClearMonthForm(String header, String text) {
        ClearMonthForm = new Form(header);
        ClearMonthForm.append(text);
        ClearMonthForm.addCommand(CMD_OK);
        ClearMonthForm.addCommand(CMD_CANCEL);
        ClearMonthForm.setCommandListener(this);

        Display.getDisplay(this).setCurrent(ClearMonthForm);
    }

    private void ShowExportList() {
        Image export_icons[];

        try {
            export_icons = new Image[2];

            export_icons[0] = Image.createImage(EXPORT_CSV_ICON);
            export_icons[1] = Image.createImage(EXPORT_GDOCS_ICON);
        } catch (Exception ex) {
            export_icons = null;
        }

        ExportList = new List("Export Data To", Choice.IMPLICIT, EXPORT_DSTS, export_icons);
        ExportList.addCommand(CMD_SELECT);
        ExportList.addCommand(CMD_BACK);
        ExportList.setSelectCommand(CMD_SELECT);
        ExportList.setCommandListener(this);

        Display.getDisplay(this).setCurrent(ExportList);
    }

    private void ShowCSVExportForm() {
        int    selected_disk = 0;
        String root_names[];
        Vector roots;

        roots = UtilClass.GetFileSystemRoots();

        root_names = new String[roots.size()];

        for (int i = 0; i < roots.size(); i++) {
            root_names[i] = (String)roots.elementAt(i);

            if (SettingStorageClass.GetCSVDisk().equals((String)roots.elementAt(i))) {
                selected_disk = i;
            }
        }

        CSVExportWalletChoiceGroup    = new ChoiceGroup("Wallet", ChoiceGroup.POPUP, EXPORT_WALLETS, null);
        CSVExportPeriodChoiceGroup    = new ChoiceGroup("Period", ChoiceGroup.POPUP, EXPORT_PERIODS, null);
        CSVExportDelimiterChoiceGroup = new ChoiceGroup("CSV Delimiter", ChoiceGroup.POPUP, CSV_DELIMITERS, null);
        CSVExportFSRootChoiceGroup    = new ChoiceGroup("Disk", ChoiceGroup.POPUP, root_names, null);
        CSVExportFileNameTextField    = new TextField("File Name", SettingStorageClass.GetCSVFileName(), 64, TextField.ANY);

        if (SettingStorageClass.GetDecimalSeparator().equals(",")) {
            CSVExportDelimiterChoiceGroup.setSelectedIndex(CSV_DELIMITER_SEMICOLON, true);
        } else {
            CSVExportDelimiterChoiceGroup.setSelectedIndex(CSV_DELIMITER_COMMA, true);
        }

        if (CSVExportFSRootChoiceGroup.size() != 0) {
            CSVExportFSRootChoiceGroup.setSelectedIndex(selected_disk, true);
        }

        CSVExportForm = new Form("Export To CSV File");
        CSVExportForm.append(CSVExportWalletChoiceGroup);
        CSVExportForm.append(CSVExportPeriodChoiceGroup);
        CSVExportForm.append(CSVExportDelimiterChoiceGroup);
        CSVExportForm.append(CSVExportFSRootChoiceGroup);
        CSVExportForm.append(CSVExportFileNameTextField);
        CSVExportForm.addCommand(CMD_OK);
        CSVExportForm.addCommand(CMD_BACK);
        CSVExportForm.setCommandListener(this);

        Display.getDisplay(this).setCurrent(CSVExportForm);
    }

    private void ShowGDocsExportForm() {
        GDocsExportWalletChoiceGroup        = new ChoiceGroup("Wallet", ChoiceGroup.POPUP, EXPORT_WALLETS, null);
        GDocsExportPeriodChoiceGroup        = new ChoiceGroup("Period", ChoiceGroup.POPUP, EXPORT_PERIODS, null);
        GDocsExportAccountNameTextField     = new TextField("Google Account Name", SettingStorageClass.GetGoogleAccountName(), 64, TextField.ANY);
        GDocsExportAccountPassTextField     = new TextField("Google Account Password", SettingStorageClass.GetGoogleAccountPass(), 64, TextField.ANY | TextField.PASSWORD);
        GDocsExportSpreadsheetNameTextField = new TextField("Google Spreadsheet Name", SettingStorageClass.GetGoogleSpreadsheetName(), 64, TextField.ANY);

        GDocsExportForm = new Form("Export To Google Spreadsheet");
        GDocsExportForm.append(GDocsExportWalletChoiceGroup);
        GDocsExportForm.append(GDocsExportPeriodChoiceGroup);
        GDocsExportForm.append(GDocsExportAccountNameTextField);
        GDocsExportForm.append(GDocsExportAccountPassTextField);
        GDocsExportForm.append(GDocsExportSpreadsheetNameTextField);
        GDocsExportForm.addCommand(CMD_OK);
        GDocsExportForm.addCommand(CMD_BACK);
        GDocsExportForm.setCommandListener(this);

        Display.getDisplay(this).setCurrent(GDocsExportForm);
    }

    private void ShowImportList() {
        Image import_icons[];

        try {
            import_icons = new Image[2];

            import_icons[0] = Image.createImage(IMPORT_CSV_ICON);
            import_icons[1] = Image.createImage(IMPORT_GDOCS_ICON);
        } catch (Exception ex) {
            import_icons = null;
        }

        ImportList = new List("Import Data From", Choice.IMPLICIT, IMPORT_SRCS, import_icons);
        ImportList.addCommand(CMD_SELECT);
        ImportList.addCommand(CMD_BACK);
        ImportList.setSelectCommand(CMD_SELECT);
        ImportList.setCommandListener(this);

        Display.getDisplay(this).setCurrent(ImportList);
    }

    private void ShowCSVImportForm() {
        int    selected_disk = 0;
        String root_names[];
        Vector roots;

        roots = UtilClass.GetFileSystemRoots();

        root_names = new String[roots.size()];

        for (int i = 0; i < roots.size(); i++) {
            root_names[i] = (String)roots.elementAt(i);

            if (SettingStorageClass.GetCSVDisk().equals((String)roots.elementAt(i))) {
                selected_disk = i;
            }
        }

        CSVImportDelimiterChoiceGroup = new ChoiceGroup("CSV Delimiter", ChoiceGroup.POPUP, CSV_DELIMITERS, null);
        CSVImportFSRootChoiceGroup    = new ChoiceGroup("Disk", ChoiceGroup.POPUP, root_names, null);
        CSVImportFileNameTextField    = new TextField("File Name", SettingStorageClass.GetCSVFileName(), 64, TextField.ANY);

        if (SettingStorageClass.GetDecimalSeparator().equals(",")) {
            CSVImportDelimiterChoiceGroup.setSelectedIndex(CSV_DELIMITER_SEMICOLON, true);
        } else {
            CSVImportDelimiterChoiceGroup.setSelectedIndex(CSV_DELIMITER_COMMA, true);
        }

        if (CSVImportFSRootChoiceGroup.size() != 0) {
            CSVImportFSRootChoiceGroup.setSelectedIndex(selected_disk, true);
        }

        CSVImportForm = new Form("Import From CSV File");
        CSVImportForm.append(CSVImportDelimiterChoiceGroup);
        CSVImportForm.append(CSVImportFSRootChoiceGroup);
        CSVImportForm.append(CSVImportFileNameTextField);
        CSVImportForm.addCommand(CMD_OK);
        CSVImportForm.addCommand(CMD_BACK);
        CSVImportForm.setCommandListener(this);

        Display.getDisplay(this).setCurrent(CSVImportForm);
    }

    private void ShowGDocsImportForm() {
        GDocsImportAccountNameTextField     = new TextField("Google Account Name", SettingStorageClass.GetGoogleAccountName(), 64, TextField.ANY);
        GDocsImportAccountPassTextField     = new TextField("Google Account Password", SettingStorageClass.GetGoogleAccountPass(), 64, TextField.ANY | TextField.PASSWORD);
        GDocsImportSpreadsheetNameTextField = new TextField("Google Spreadsheet Name", SettingStorageClass.GetGoogleSpreadsheetName(), 64, TextField.ANY);

        GDocsImportForm = new Form("Import From Google Spreadsheet");
        GDocsImportForm.append(GDocsImportAccountNameTextField);
        GDocsImportForm.append(GDocsImportAccountPassTextField);
        GDocsImportForm.append(GDocsImportSpreadsheetNameTextField);
        GDocsImportForm.addCommand(CMD_OK);
        GDocsImportForm.addCommand(CMD_BACK);
        GDocsImportForm.setCommandListener(this);

        Display.getDisplay(this).setCurrent(GDocsImportForm);
    }

    private void ShowCreateInitialBalancesForm(String header, String text) {
        CreateInitialBalancesForm = new Form(header);
        CreateInitialBalancesForm.append(text);
        CreateInitialBalancesForm.addCommand(CMD_OK);
        CreateInitialBalancesForm.addCommand(CMD_CANCEL);
        CreateInitialBalancesForm.setCommandListener(this);

        Display.getDisplay(this).setCurrent(CreateInitialBalancesForm);
    }

    private void ShowSelectInitialBalanceCategoryForm() {
        int    selected_category = 0;
        String category_names[];
        Vector categories;

        try {
            categories = CategoryStorageClass.GetListSortedByName();

            SelectInitialBalanceCategoryFormCategoryIds = new int[categories.size()];
            category_names                              = new String[categories.size()];

            for (int i = 0; i < categories.size(); i++) {
                SelectInitialBalanceCategoryFormCategoryIds[i] = ((CategoryClass)categories.elementAt(i)).GetId();
                category_names[i]                              = ((CategoryClass)categories.elementAt(i)).GetName();

                if (SettingStorageClass.GetInitialBalanceCategoryId() == ((CategoryClass)categories.elementAt(i)).GetId()) {
                    selected_category = i;
                }
            }

            SelectInitialBalanceCategoryCategoryChoiceGroup = new ChoiceGroup("Category", ChoiceGroup.EXCLUSIVE, category_names, null);

            SelectInitialBalanceCategoryCategoryChoiceGroup.setSelectedIndex(selected_category, true);

            SelectInitialBalanceCategoryForm = new Form("Select Initial Balance Category");
            SelectInitialBalanceCategoryForm.append(SelectInitialBalanceCategoryCategoryChoiceGroup);
            SelectInitialBalanceCategoryForm.addCommand(CMD_OK);
            SelectInitialBalanceCategoryForm.addCommand(CMD_CANCEL);
            SelectInitialBalanceCategoryForm.setCommandListener(this);

            Display.getDisplay(this).setCurrent(SelectInitialBalanceCategoryForm);
        } catch (Exception ex) {
            ShowErrorMessage(ex.toString());
        }
    }

    public void startApp() {
        synchronized (this) {
            if (AppState == APP_STARTED) {
                CurrentMonth.setTime(new Date());
                CurrentDateFilter.setTime(new Date());

                try {
                    SettingStorageClass.Initialize();
                    WalletStorageClass.Initialize();
                    CategoryStorageClass.Initialize();

                    if (TransactionStorageClass.GetCount()                     != 0 &&
                        TransactionStorageClass.GetCountForMonth(CurrentMonth) == 0) {
                        ShowCreateInitialBalancesForm("Create Initial Balance Records", "A new month has begun. " +
                                                      "Do you want to create initial balance records for all your wallets " +
                                                      "automatically using their balances at the end of the previous month ?");
                    } else {
                        ShowWalletBalanceTable();
                    }
                } catch (Exception ex) {
                    ShowInitErrorMessage(ex.toString());
                }
            }

            AppState = APP_ACTIVE;
        }
    }

    public void pauseApp() {
    }

    public void destroyApp(boolean unconditional) {
        synchronized (this) {
            if (AppState == APP_ACTIVE) {
                if (BgOperationThread != null) {
                    CSVOperatorClass.StopOperation();
                    GDocsOperatorClass.StopOperation();

                    try {
                        BgOperationThread.join();
                    } catch (Exception ex) {
                        // Ignore
                    }
                }
            }

            AppState = APP_DESTROYED;
        }
    }

    public void commandAction(Command command, Displayable displayable) {
        synchronized (this) {
            if (command == CMD_EXIT) {
                destroyApp(true);

                notifyDestroyed();
            } else if (displayable.equals(ProgressAlert)) {
                // Ignore
            } else if (displayable.equals(CSVProgressAlert)) {
                if (command == CMD_CANCEL) {
                    CSVOperatorClass.StopOperation();
                }
            } else if (displayable.equals(GDocsProgressAlert)) {
                if (command == CMD_CANCEL) {
                    GDocsOperatorClass.StopOperation();
                }
            } else if (displayable.equals(AboutForm)) {
                if (command == CMD_BACK) {
                    ShowWalletBalanceTable();
                }
            } else if (displayable.equals(HelpForm)) {
                if (command == CMD_BACK) {
                    ShowWalletBalanceTable();
                }
            } else if (displayable.equals(WalletBalanceTable)) {
                if (command == CMD_SELECT) {
                    if (WalletBalanceTable.GetSelectedIndex() != -1) {
                        CurrentMonth    = WalletBalanceTable.GetMonth();
                        CurrentWalletId = WalletBalanceTable.GetWalletId(WalletBalanceTable.GetSelectedIndex());

                        WalletClass wallet = WalletStorageClass.Get(CurrentWalletId);

                        if (wallet != null) {
                            CurrentWalletName = wallet.GetName();

                            ShowWalletTransactionsTable();
                        } else {
                            ShowErrorMessage("Invalid wallet");
                        }
                    }
                } else if (command == CMD_OPTIONS) {
                    CurrentMonth = WalletBalanceTable.GetMonth();

                    LastDisplayable = Display.getDisplay(this).getCurrent();
                    ShowOptionsList();
                } else if (command == CMD_CLRMONTH) {
                    CurrentMonth = WalletBalanceTable.GetMonth();

                    ShowClearMonthForm("Clear Month", "Clear " + UtilClass.GetCalendarMonthName(CurrentMonth) + " " +
                                                      String.valueOf(CurrentMonth.get(Calendar.YEAR)) + " ?");
                } else if (command == CMD_EXPORT) {
                    CurrentMonth = WalletBalanceTable.GetMonth();

                    ShowExportList();
                } else if (command == CMD_IMPORT) {
                    CurrentMonth = WalletBalanceTable.GetMonth();

                    ShowImportList();
                } else if (command == CMD_HELP) {
                    CurrentMonth = WalletBalanceTable.GetMonth();

                    ShowHelpForm();
                } else if (command == CMD_ABOUT) {
                    CurrentMonth = WalletBalanceTable.GetMonth();

                    ShowAboutForm();
                }
            } else if (displayable.equals(WalletTransactionsTable)) {
                if (command == CMD_ADD) {
                    if (CategoryStorageClass.GetCount() != 0) {
                        CurrentMonth    = WalletTransactionsTable.GetMonth();
                        CurrentViewType = WalletTransactionsTable.GetViewType();

                        ShowAddTransactionForm();
                    } else {
                        ShowErrorMessage("No categories defined");
                    }
                } else if (command == CMD_EDIT) {
                    if (CategoryStorageClass.GetCount() != 0) {
                        if (WalletTransactionsTable.GetSelectedIndex() != -1) {
                            CurrentMonth    = WalletTransactionsTable.GetMonth();
                            CurrentViewType = WalletTransactionsTable.GetViewType();

                            try {
                                TransactionClass transaction = TransactionStorageClass.Get(WalletTransactionsTable.GetTransactionId(WalletTransactionsTable.GetSelectedIndex()));

                                ShowEditTransactionForm(transaction);
                            } catch (Exception ex) {
                                ShowErrorMessage(ex.toString());
                            }
                        }
                    } else {
                        ShowErrorMessage("No categories defined");
                    }
                } else if (command == CMD_DELETE) {
                    if (WalletTransactionsTable.GetSelectedIndex() != -1) {
                        CurrentMonth    = WalletTransactionsTable.GetMonth();
                        CurrentViewType = WalletTransactionsTable.GetViewType();

                        try {
                            String amount;
                            TransactionClass transaction = TransactionStorageClass.Get(WalletTransactionsTable.GetTransactionId(WalletTransactionsTable.GetSelectedIndex()));
                            CategoryClass    category    = CategoryStorageClass.Get(transaction.GetCategoryId());

                            if (category != null) {
                                if (transaction.GetAmount() > 0) {
                                    amount = "+" + UtilClass.MoneyToString(transaction.GetAmount());
                                } else {
                                    amount =       UtilClass.MoneyToString(transaction.GetAmount());
                                }

                                ShowDeleteTransactionForm("Delete Transaction", "Delete transaction \"" +
                                                          category.GetName() + " : " + amount +
                                                          "\" ?");
                            } else {
                                throw (new Exception("Invalid category"));
                            }
                        } catch (Exception ex) {
                            ShowErrorMessage(ex.toString());
                        }
                    }
                } else if (command == CMD_TRANSFER) {
                    if (WalletStorageClass.GetCount() > 1) {
                        if (CategoryStorageClass.GetCount() != 0) {
                            CurrentMonth    = WalletTransactionsTable.GetMonth();
                            CurrentViewType = WalletTransactionsTable.GetViewType();

                            ShowTransferForm();
                        } else {
                            ShowErrorMessage("No categories defined");
                        }
                    } else {
                        ShowErrorMessage("At least two wallets should be defined for money transfer");
                    }
                } else if (command == CMD_SWVIEW) {
                    WalletTransactionsTable.SwitchView();
                } else if (command == CMD_FILTER) {
                    CurrentMonth    = WalletTransactionsTable.GetMonth();
                    CurrentViewType = WalletTransactionsTable.GetViewType();

                    ShowFilterTransactionsForm();
                } else if (command == CMD_STATISTICS) {
                    CurrentMonth    = WalletTransactionsTable.GetMonth();
                    CurrentViewType = WalletTransactionsTable.GetViewType();

                    ShowWalletTotalsPerCategoryStatisticsTable();
                } else if (command == CMD_OPTIONS) {
                    CurrentMonth    = WalletTransactionsTable.GetMonth();
                    CurrentViewType = WalletTransactionsTable.GetViewType();

                    LastDisplayable = Display.getDisplay(this).getCurrent();
                    ShowOptionsList();
                } else if (command == CMD_BACK) {
                    CurrentMonth    = WalletTransactionsTable.GetMonth();
                    CurrentViewType = WalletTransactionsTable.GetViewType();

                    ShowWalletBalanceTable();
                }
            } else if (displayable.equals(WalletTotalsPerCategoryStatisticsTable)) {
                if (command == CMD_STAT_PER_DAY) {
                    CurrentMonth = WalletTotalsPerCategoryStatisticsTable.GetMonth();

                    ShowWalletChargeIncomePerDayStatisticsTable();
                } else if (command == CMD_BACK) {
                    CurrentMonth = WalletTotalsPerCategoryStatisticsTable.GetMonth();

                    ShowWalletTransactionsTable();
                }
            } else if (displayable.equals(WalletChargeIncomePerDayStatisticsTable)) {
                if (command == CMD_STAT_PER_CATEGORY) {
                    CurrentMonth = WalletChargeIncomePerDayStatisticsTable.GetMonth();

                    ShowWalletTotalsPerCategoryStatisticsTable();
                } else if (command == CMD_BACK) {
                    CurrentMonth = WalletChargeIncomePerDayStatisticsTable.GetMonth();

                    ShowWalletTransactionsTable();
                }
            } else if (displayable.equals(AddTransactionForm)) {
                if (command == CMD_SAVE) {
                    if (AddTransactionCategoryChoiceGroup.getSelectedIndex() != -1) {
                        try {
                            long amount = MoneyExpressionEvaluatorClass.Evaluate(AddTransactionTransactionAmountTextField.getString());

                            if (amount < 0) {
                                throw (new Exception("Negative amount"));
                            }
                            if (AddTransactionTypeChoiceGroup.getSelectedIndex() == TRANSACTION_TYPE_CHARGE) {
                                amount = -amount;
                            }
                            TransactionClass transaction = new TransactionClass(CurrentWalletId,
                                                                                AddTransactionFormCategoryIds[AddTransactionCategoryChoiceGroup.getSelectedIndex()],
                                                                                amount,
                                                                                AddTransactionTransactionDateDateField.getDate(),
                                                                                AddTransactionTransactionCommentTextField.getString());

                            if (TransactionStorageClass.Validate(transaction)) {
                                try {
                                    TransactionStorageClass.Add(transaction);

                                    CurrentMonth.setTime(AddTransactionTransactionDateDateField.getDate());

                                    ShowWalletTransactionsTable();
                                } catch (Exception ex) {
                                    ShowErrorMessage(ex.toString());
                                }
                            } else {
                                ShowErrorMessage(TransactionStorageClass.GetValidateErrorMsg());
                            }
                        } catch (Exception ex) {
                            ShowErrorMessage("Amount should be valid arithmetic expression with non-negative operands and non-negative result");
                        }
                    } else {
                        ShowErrorMessage("No category selected");
                    }
                } else if (command == CMD_BACK) {
                    ShowWalletTransactionsTable();
                }
            } else if (displayable.equals(EditTransactionForm)) {
                if (command == CMD_SAVE) {
                    if (WalletTransactionsTable.GetSelectedIndex() != -1) {
                        if (EditTransactionCategoryChoiceGroup.getSelectedIndex() != -1) {
                            try {
                                long amount = MoneyExpressionEvaluatorClass.Evaluate(EditTransactionTransactionAmountTextField.getString());

                                if (amount < 0) {
                                    throw (new Exception("Negative amount"));
                                }
                                if (EditTransactionTypeChoiceGroup.getSelectedIndex() == TRANSACTION_TYPE_CHARGE) {
                                    amount = -amount;
                                }
                                TransactionClass transaction = new TransactionClass(CurrentWalletId,
                                                                                    EditTransactionFormCategoryIds[EditTransactionCategoryChoiceGroup.getSelectedIndex()],
                                                                                    amount,
                                                                                    EditTransactionTransactionDateDateField.getDate(),
                                                                                    EditTransactionTransactionCommentTextField.getString());

                                if (TransactionStorageClass.Validate(transaction)) {
                                    try {
                                        TransactionStorageClass.Replace(WalletTransactionsTable.GetTransactionId(WalletTransactionsTable.GetSelectedIndex()), transaction);

                                        CurrentMonth.setTime(EditTransactionTransactionDateDateField.getDate());

                                        ShowWalletTransactionsTable();
                                    } catch (Exception ex) {
                                        ShowErrorMessage(ex.toString());
                                    }
                                } else {
                                    ShowErrorMessage(TransactionStorageClass.GetValidateErrorMsg());
                                }
                            } catch (Exception ex) {
                                ShowErrorMessage("Amount should be valid arithmetic expression with non-negative operands and non-negative result");
                            }
                        } else {
                            ShowErrorMessage("No category selected");
                        }
                    }
                } else if (command == CMD_BACK) {
                    ShowWalletTransactionsTable();
                }
            } else if (displayable.equals(DeleteTransactionForm)) {
                if (command == CMD_OK) {
                    if (WalletTransactionsTable.GetSelectedIndex() != -1) {
                        try {
                            TransactionStorageClass.Delete(WalletTransactionsTable.GetTransactionId(WalletTransactionsTable.GetSelectedIndex()));

                            ShowWalletTransactionsTable();
                        } catch (Exception ex) {
                            ShowErrorMessage(ex.toString());
                        }
                    }
                } else if (command == CMD_CANCEL) {
                    ShowWalletTransactionsTable();
                }
            } else if (displayable.equals(TransferForm)) {
                if (command == CMD_OK) {
                    if (TransferDestinationWalletChoiceGroup.getSelectedIndex() != -1) {
                        if (TransferChargeCategoryChoiceGroup.getSelectedIndex() != -1) {
                            if (TransferIncomeCategoryChoiceGroup.getSelectedIndex() != -1) {
                                if (TransferFormWalletIds[TransferDestinationWalletChoiceGroup.getSelectedIndex()] != CurrentWalletId) {
                                    try {
                                        SettingStorageClass.SetTransferChargeCategoryId(TransferFormCategoryIds[TransferChargeCategoryChoiceGroup.getSelectedIndex()]);
                                        SettingStorageClass.SetTransferIncomeCategoryId(TransferFormCategoryIds[TransferIncomeCategoryChoiceGroup.getSelectedIndex()]);

                                        try {
                                            long amount = MoneyExpressionEvaluatorClass.Evaluate(TransferTransactionAmountTextField.getString());

                                            if (amount < 0) {
                                                throw (new Exception("Negative amount"));
                                            }
                                            TransactionClass charge_transaction = new TransactionClass(CurrentWalletId,
                                                                                                       TransferFormCategoryIds[TransferChargeCategoryChoiceGroup.getSelectedIndex()],
                                                                                                       -amount,
                                                                                                       TransferTransactionDateDateField.getDate(),
                                                                                                       "Transfer to " + WalletStorageClass.Get(TransferFormWalletIds[TransferDestinationWalletChoiceGroup.getSelectedIndex()]).GetName());
                                            TransactionClass income_transaction = new TransactionClass(TransferFormWalletIds[TransferDestinationWalletChoiceGroup.getSelectedIndex()],
                                                                                                       TransferFormCategoryIds[TransferIncomeCategoryChoiceGroup.getSelectedIndex()],
                                                                                                       amount,
                                                                                                       TransferTransactionDateDateField.getDate(),
                                                                                                       "Transfer from " + CurrentWalletName);

                                            if (TransactionStorageClass.Validate(charge_transaction) &&
                                                TransactionStorageClass.Validate(income_transaction)) {
                                                try {
                                                    TransactionStorageClass.Add(charge_transaction);
                                                    TransactionStorageClass.Add(income_transaction);

                                                    CurrentMonth.setTime(TransferTransactionDateDateField.getDate());

                                                    ShowWalletTransactionsTable();
                                                } catch (Exception ex) {
                                                    ShowErrorMessage(ex.toString());
                                                }
                                            } else {
                                                ShowErrorMessage(TransactionStorageClass.GetValidateErrorMsg());
                                            }
                                        } catch (Exception ex) {
                                            ShowErrorMessage("Amount should be valid arithmetic expression with non-negative operands and non-negative result");
                                        }
                                    } catch (Exception ex) {
                                        ShowErrorMessage(ex.toString());
                                    }
                                } else {
                                    ShowErrorMessage("Money transfer to the same wallet is not allowed");
                                }
                            } else {
                                ShowErrorMessage("No income category selected");
                            }
                        } else {
                            ShowErrorMessage("No charge category selected");
                        }
                    } else {
                        ShowErrorMessage("No destination wallet selected");
                    }
                } else if (command == CMD_BACK) {
                    ShowWalletTransactionsTable();
                }
            } else if (displayable.equals(FilterTransactionsForm)) {
                if (command == CMD_OK) {
                    if (FilterTransactionsCategoryChoiceGroup.getSelectedIndex() != -1) {
                        if (FilterTransactionsDateFilterTypeChoiceGroup.getSelectedIndex() != -1) {
                            CurrentCategoryFilterId = FilterTransactionsFormCategoryIds[FilterTransactionsCategoryChoiceGroup.getSelectedIndex()];
                            CurrentDateFilterType   = FilterTransactionsDateFilterTypeChoiceGroup.getSelectedIndex();

                            CurrentDateFilter.setTime(FilterTransactionsDateFilterDateField.getDate());

                            if (CurrentDateFilterType == DATE_FILTER_TYPE_SPEC_DATE) {
                                CurrentMonth.setTime(CurrentDateFilter.getTime());
                            }

                            ShowWalletTransactionsTable();
                        } else {
                            ShowErrorMessage("No filter by date selected");
                        }
                    } else {
                        ShowErrorMessage("No category selected");
                    }
                } else if (command == CMD_BACK) {
                    ShowWalletTransactionsTable();
                }
            } else if (displayable.equals(OptionsList)) {
                if (command == CMD_SELECT) {
                    if (OptionsList.getSelectedIndex() == OPTION_WALLETS) {
                        ShowWalletsList();
                    } else if (OptionsList.getSelectedIndex() == OPTION_CATEGORIES) {
                        ShowCategoriesList();
                    } else if (OptionsList.getSelectedIndex() == OPTION_SETTINGS) {
                        ShowSettingsForm();
                    }
                } else if (command == CMD_BACK) {
                    if (LastDisplayable == WalletBalanceTable) {
                        ShowWalletBalanceTable();
                    } else if (LastDisplayable == WalletTransactionsTable) {
                        if (WalletStorageClass.Get(CurrentWalletId) != null) {
                            ShowWalletTransactionsTable();
                        } else {
                            ShowWalletBalanceTable();
                        }
                    } else {
                        ShowWalletBalanceTable();
                    }
                }
            } else if (displayable.equals(WalletsList)) {
                if (command == CMD_ADD) {
                    ShowAddWalletForm();
                } else if (command == CMD_EDIT) {
                    if (WalletsList.getSelectedIndex() != -1) {
                        WalletClass wallet = WalletStorageClass.Get(WalletsListIds[WalletsList.getSelectedIndex()]);

                        if (wallet != null) {
                            ShowEditWalletForm(wallet);
                        } else {
                            ShowErrorMessage("Invalid wallet");
                        }
                    }
                } else if (command == CMD_DELETE) {
                    if (WalletsList.getSelectedIndex() != -1) {
                        ShowDeleteWalletForm("Delete Wallet", "Delete wallet \"" +
                                             WalletsList.getString(WalletsList.getSelectedIndex()) + "\" ?");
                    }
                } else if (command == CMD_BACK) {
                    ShowOptionsList();
                }
            } else if (displayable.equals(AddWalletForm)) {
                if (command == CMD_SAVE) {
                    WalletClass wallet = new WalletClass(AddWalletWalletNameTextField.getString());

                    if (WalletStorageClass.Validate(wallet)) {
                        try {
                            WalletStorageClass.Add(wallet);

                            ShowWalletsList();
                        } catch (Exception ex) {
                            ShowErrorMessage(ex.toString());
                        }
                    } else {
                        ShowErrorMessage(WalletStorageClass.GetValidateErrorMsg());
                    }
                } else if (command == CMD_BACK) {
                    ShowWalletsList();
                }
            } else if (displayable.equals(EditWalletForm)) {
                if (command == CMD_SAVE) {
                    if (WalletsList.getSelectedIndex() != -1) {
                        WalletClass wallet = new WalletClass(EditWalletWalletNameTextField.getString());

                        if (WalletStorageClass.Validate(wallet)) {
                            try {
                                WalletStorageClass.Replace(WalletsListIds[WalletsList.getSelectedIndex()], wallet);

                                ShowWalletsList();
                            } catch (Exception ex) {
                                ShowErrorMessage(ex.toString());
                            }
                        } else {
                            ShowErrorMessage(WalletStorageClass.GetValidateErrorMsg());
                        }
                    }
                } else if (command == CMD_BACK) {
                    ShowWalletsList();
                }
            } else if (displayable.equals(DeleteWalletForm)) {
                if (command == CMD_OK) {
                    if (WalletsList.getSelectedIndex() != -1) {
                        if (BgOperationThread == null || !BgOperationThread.isAlive()) {
                            BgOperationThread = new Thread() {
                                public void run() {
                                    try {
                                        ShowProgressMessage("Deleting wallet...");

                                        TransactionStorageClass.DeleteForWalletId(WalletsListIds[WalletsList.getSelectedIndex()]);
                                        WalletStorageClass.Delete(WalletsListIds[WalletsList.getSelectedIndex()]);

                                        ShowWalletsList();
                                    } catch (Exception ex) {
                                        ShowErrorMessage(ex.toString(), DeleteWalletForm);
                                    }
                                }
                            };

                            BgOperationThread.start();
                        }
                    }
                } else if (command == CMD_CANCEL) {
                    ShowWalletsList();
                }
            } else if (displayable.equals(CategoriesList)) {
                if (command == CMD_ADD) {
                    ShowAddCategoryForm();
                } else if (command == CMD_EDIT) {
                    if (CategoriesList.getSelectedIndex() != -1) {
                        CategoryClass category = CategoryStorageClass.Get(CategoriesListIds[CategoriesList.getSelectedIndex()]);

                        if (category != null) {
                            ShowEditCategoryForm(category);
                        } else {
                            ShowErrorMessage("Invalid category");
                        }
                    }
                } else if (command == CMD_DELETE) {
                    if (CategoriesList.getSelectedIndex() != -1) {
                        ShowDeleteCategoryForm("Delete Category", "Delete category \"" +
                                               CategoriesList.getString(CategoriesList.getSelectedIndex()) + "\" ?");
                    }
                } else if (command == CMD_BACK) {
                    ShowOptionsList();
                }
            } else if (displayable.equals(AddCategoryForm)) {
                if (command == CMD_SAVE) {
                    CategoryClass category = new CategoryClass(AddCategoryCategoryNameTextField.getString());

                    if (CategoryStorageClass.Validate(category)) {
                        try {
                            CategoryStorageClass.Add(category);

                            ShowCategoriesList();
                        } catch (Exception ex) {
                            ShowErrorMessage(ex.toString());
                        }
                    } else {
                        ShowErrorMessage(CategoryStorageClass.GetValidateErrorMsg());
                    }
                } else if (command == CMD_BACK) {
                    ShowCategoriesList();
                }
            } else if (displayable.equals(EditCategoryForm)) {
                if (command == CMD_SAVE) {
                    if (CategoriesList.getSelectedIndex() != -1) {
                        CategoryClass category = new CategoryClass(EditCategoryCategoryNameTextField.getString());

                        if (CategoryStorageClass.Validate(category)) {
                            try {
                                CategoryStorageClass.Replace(CategoriesListIds[CategoriesList.getSelectedIndex()], category);

                                ShowCategoriesList();
                            } catch (Exception ex) {
                                ShowErrorMessage(ex.toString());
                            }
                        } else {
                            ShowErrorMessage(CategoryStorageClass.GetValidateErrorMsg());
                        }
                    }
                } else if (command == CMD_BACK) {
                    ShowCategoriesList();
                }
            } else if (displayable.equals(DeleteCategoryForm)) {
                if (command == CMD_OK) {
                    if (CategoriesList.getSelectedIndex() != -1) {
                        if (BgOperationThread == null || !BgOperationThread.isAlive()) {
                            BgOperationThread = new Thread() {
                                public void run() {
                                    try {
                                        ShowProgressMessage("Deleting category...");

                                        TransactionStorageClass.DeleteForCategoryId(CategoriesListIds[CategoriesList.getSelectedIndex()]);
                                        CategoryStorageClass.Delete(CategoriesListIds[CategoriesList.getSelectedIndex()]);

                                        ShowCategoriesList();
                                    } catch (Exception ex) {
                                        ShowErrorMessage(ex.toString(), DeleteCategoryForm);
                                    }
                                }
                            };

                            BgOperationThread.start();
                        }
                    }
                } else if (command == CMD_CANCEL) {
                    ShowCategoriesList();
                }
            } else if (displayable.equals(SettingsForm)) {
                if (command == CMD_SAVE) {
                    if (SettingsDecimalSeparatorChoiceGroup.getSelectedIndex() != -1) {
                        try {
                            SettingStorageClass.SetDecimalSeparator(SettingsDecimalSeparatorChoiceGroup.getString(SettingsDecimalSeparatorChoiceGroup.getSelectedIndex()));

                            ShowOptionsList();
                        } catch (Exception ex) {
                            ShowErrorMessage(ex.toString());
                        }
                    } else {
                        ShowErrorMessage("No decimal separator selected");
                    }
                } else if (command == CMD_BACK) {
                    ShowOptionsList();
                }
            } else if (displayable.equals(ClearMonthForm)) {
                if (command == CMD_OK) {
                    if (BgOperationThread == null || !BgOperationThread.isAlive()) {
                        BgOperationThread = new Thread() {
                            public void run() {
                                try {
                                    ShowProgressMessage("Clearing month...");

                                    TransactionStorageClass.DeleteForMonth(CurrentMonth);

                                    ShowWalletBalanceTable();
                                } catch (Exception ex) {
                                    ShowErrorMessage(ex.toString(), ClearMonthForm);
                                }
                            }
                        };

                        BgOperationThread.start();
                    }
                } else if (command == CMD_CANCEL) {
                    ShowWalletBalanceTable();
                }
            } else if (displayable.equals(ExportList)) {
                if (command == CMD_SELECT) {
                    if (ExportList.getSelectedIndex() == EXPORT_DST_CSV) {
                        if (UtilClass.ValidateFileConnectionAPI()) {
                            ShowCSVExportForm();
                        } else {
                            ShowErrorMessage("CSV import/export operations are not available on this platform");
                        }
                    } else if (ExportList.getSelectedIndex() == EXPORT_DST_GDOCS) {
                        ShowGDocsExportForm();
                    }
                } else if (command == CMD_BACK) {
                    ShowWalletBalanceTable();
                }
            } else if (displayable.equals(CSVExportForm)) {
                if (command == CMD_OK) {
                    if (UtilClass.ValidateFileConnectionAPI()) {
                        if (CSVExportDelimiterChoiceGroup.getSelectedIndex() != -1) {
                            if (CSVExportFSRootChoiceGroup.getSelectedIndex() != -1) {
                                try {
                                    SettingStorageClass.SetCSVDisk(CSVExportFSRootChoiceGroup.getString(CSVExportFSRootChoiceGroup.getSelectedIndex()));
                                    SettingStorageClass.SetCSVFileName(CSVExportFileNameTextField.getString());

                                    final int      wallet_id;
                                    final Calendar month;

                                    if (CSVExportWalletChoiceGroup.getSelectedIndex() == EXPORT_WALLET_SELECTED) {
                                        wallet_id = WalletBalanceTable.GetWalletId(WalletBalanceTable.GetSelectedIndex());
                                    } else {
                                        wallet_id = 0;
                                    }
                                    if (CSVExportPeriodChoiceGroup.getSelectedIndex() == EXPORT_PERIOD_SELECTED_MONTH) {
                                        month = CurrentMonth;
                                    } else {
                                        month = null;
                                    }
                                    final String delimiter = CSVExportDelimiterChoiceGroup.getString(CSVExportDelimiterChoiceGroup.getSelectedIndex());
                                    final String root_name = CSVExportFSRootChoiceGroup.getString(CSVExportFSRootChoiceGroup.getSelectedIndex());
                                    final String file_name = CSVExportFileNameTextField.getString();

                                    if (!file_name.equals("")) {
                                        if (BgOperationThread == null || !BgOperationThread.isAlive()) {
                                            CSVOperatorClass.StartOperation();

                                            BgOperationThread = new Thread() {
                                                public void run() {
                                                    try {
                                                        ShowCSVProgressMessage("Exporting to CSV file...");

                                                        int exported_records = CSVOperatorClass.ExportToCSV(root_name, file_name, wallet_id,
                                                                                                            month, delimiter.charAt(0), CSVProgressAlert);

                                                        if (CSVOperatorClass.OperationStopped()) {
                                                            ShowInfoMessage("Export was cancelled by user, " +
                                                                            String.valueOf(exported_records) + " records exported",
                                                                            CSVExportForm);
                                                        } else {
                                                            ShowInfoMessage("Export complete, " +
                                                                            String.valueOf(exported_records) + " records exported",
                                                                            CSVExportForm);
                                                        }
                                                    } catch (Exception ex) {
                                                        ShowErrorMessage(ex.toString(), CSVExportForm);
                                                    }
                                                }
                                            };

                                            BgOperationThread.start();
                                        }
                                    } else {
                                        ShowErrorMessage("File name is empty");
                                    }
                                } catch (Exception ex) {
                                    ShowErrorMessage(ex.toString());
                                }
                            } else {
                                ShowErrorMessage("No disk selected");
                            }
                        } else {
                            ShowErrorMessage("No CSV delimiter selected");
                        }
                    } else {
                        ShowErrorMessage("CSV import/export operations are not available on this platform");
                    }
                } else if (command == CMD_BACK) {
                    ShowExportList();
                }
            } else if (displayable.equals(GDocsExportForm)) {
                if (command == CMD_OK) {
                    try {
                        SettingStorageClass.SetGoogleAccountName(GDocsExportAccountNameTextField.getString());
                        SettingStorageClass.SetGoogleAccountPass(GDocsExportAccountPassTextField.getString());
                        SettingStorageClass.SetGoogleSpreadsheetName(GDocsExportSpreadsheetNameTextField.getString());

                        final int      wallet_id;
                        final Calendar month;

                        if (GDocsExportWalletChoiceGroup.getSelectedIndex() == EXPORT_WALLET_SELECTED) {
                            wallet_id = WalletBalanceTable.GetWalletId(WalletBalanceTable.GetSelectedIndex());
                        } else {
                            wallet_id = 0;
                        }
                        if (GDocsExportPeriodChoiceGroup.getSelectedIndex() == EXPORT_PERIOD_SELECTED_MONTH) {
                            month = CurrentMonth;
                        } else {
                            month = null;
                        }
                        final String acct_name  = GDocsExportAccountNameTextField.getString();
                        final String acct_pass  = GDocsExportAccountPassTextField.getString();
                        final String sheet_name = GDocsExportSpreadsheetNameTextField.getString();

                        if (!acct_name.equals("")) {
                            if (!sheet_name.equals("")) {
                                if (BgOperationThread == null || !BgOperationThread.isAlive()) {
                                    GDocsOperatorClass.StartOperation();

                                    BgOperationThread = new Thread() {
                                        public void run() {
                                            try {
                                                ShowGDocsProgressMessage("Exporting to Google spreadsheet...");

                                                int exported_records = GDocsOperatorClass.ExportToGDocs(acct_name, acct_pass, sheet_name, wallet_id,
                                                                                                        month, GDocsProgressAlert);

                                                if (GDocsOperatorClass.OperationStopped()) {
                                                    ShowInfoMessage("Export was cancelled by user, " +
                                                                    String.valueOf(exported_records) + " records exported",
                                                                    GDocsExportForm);
                                                } else {
                                                    ShowInfoMessage("Export complete, " +
                                                                    String.valueOf(exported_records) + " records exported",
                                                                    GDocsExportForm);
                                                }
                                            } catch (Exception ex) {
                                                ShowErrorMessage(ex.toString(), GDocsExportForm);
                                            }
                                        }
                                    };

                                    BgOperationThread.start();
                                }
                            } else {
                                ShowErrorMessage("Google spreadsheet name is empty");
                            }
                        } else {
                            ShowErrorMessage("Google account name is empty");
                        }
                    } catch (Exception ex) {
                        ShowErrorMessage(ex.toString());
                    }
                } else if (command == CMD_BACK) {
                    ShowExportList();
                }
            } else if (displayable.equals(ImportList)) {
                if (command == CMD_SELECT) {
                    if (ImportList.getSelectedIndex() == IMPORT_SRC_CSV) {
                        if (UtilClass.ValidateFileConnectionAPI()) {
                            ShowCSVImportForm();
                        } else {
                            ShowErrorMessage("CSV import/export operations are not available on this platform");
                        }
                    } else if (ImportList.getSelectedIndex() == IMPORT_SRC_GDOCS) {
                        ShowGDocsImportForm();
                    }
                } else if (command == CMD_BACK) {
                    ShowWalletBalanceTable();
                }
            } else if (displayable.equals(CSVImportForm)) {
                if (command == CMD_OK) {
                    if (UtilClass.ValidateFileConnectionAPI()) {
                        if (CSVImportDelimiterChoiceGroup.getSelectedIndex() != -1) {
                            if (CSVImportFSRootChoiceGroup.getSelectedIndex() != -1) {
                                try {
                                    SettingStorageClass.SetCSVDisk(CSVImportFSRootChoiceGroup.getString(CSVImportFSRootChoiceGroup.getSelectedIndex()));
                                    SettingStorageClass.SetCSVFileName(CSVImportFileNameTextField.getString());

                                    final String delimiter = CSVImportDelimiterChoiceGroup.getString(CSVImportDelimiterChoiceGroup.getSelectedIndex());
                                    final String root_name = CSVImportFSRootChoiceGroup.getString(CSVImportFSRootChoiceGroup.getSelectedIndex());
                                    final String file_name = CSVImportFileNameTextField.getString();

                                    if (!file_name.equals("")) {
                                        if (BgOperationThread == null || !BgOperationThread.isAlive()) {
                                            CSVOperatorClass.StartOperation();

                                            BgOperationThread = new Thread() {
                                                public void run() {
                                                    try {
                                                        ShowCSVProgressMessage("Importing from CSV file...");

                                                        int import_result[] = CSVOperatorClass.ImportFromCSV(root_name, file_name,
                                                                                                             delimiter.charAt(0), CSVProgressAlert);

                                                        if (CSVOperatorClass.OperationStopped()) {
                                                            ShowInfoMessage("Import was cancelled by user, " +
                                                                            String.valueOf(import_result[0]) + " records imported, " +
                                                                            String.valueOf(import_result[1]) + " errors",
                                                                            CSVImportForm);
                                                        } else {
                                                            ShowInfoMessage("Import complete, " +
                                                                            String.valueOf(import_result[0]) + " records imported, " +
                                                                            String.valueOf(import_result[1]) + " errors",
                                                                            CSVImportForm);
                                                        }
                                                    } catch (Exception ex) {
                                                        ShowErrorMessage(ex.toString(), CSVImportForm);
                                                    }
                                                }
                                            };

                                            BgOperationThread.start();
                                        }
                                    } else {
                                        ShowErrorMessage("File name is empty");
                                    }
                                } catch (Exception ex) {
                                    ShowErrorMessage(ex.toString());
                                }
                            } else {
                                ShowErrorMessage("No disk selected");
                            }
                        } else {
                            ShowErrorMessage("No CSV delimiter selected");
                        }
                    } else {
                        ShowErrorMessage("CSV import/export operations are not available on this platform");
                    }
                } else if (command == CMD_BACK) {
                    ShowImportList();
                }
            } else if (displayable.equals(GDocsImportForm)) {
                if (command == CMD_OK) {
                    try {
                        SettingStorageClass.SetGoogleAccountName(GDocsImportAccountNameTextField.getString());
                        SettingStorageClass.SetGoogleAccountPass(GDocsImportAccountPassTextField.getString());
                        SettingStorageClass.SetGoogleSpreadsheetName(GDocsImportSpreadsheetNameTextField.getString());

                        final String acct_name  = GDocsImportAccountNameTextField.getString();
                        final String acct_pass  = GDocsImportAccountPassTextField.getString();
                        final String sheet_name = GDocsImportSpreadsheetNameTextField.getString();

                        if (!acct_name.equals("")) {
                            if (!sheet_name.equals("")) {
                                if (BgOperationThread == null || !BgOperationThread.isAlive()) {
                                    GDocsOperatorClass.StartOperation();

                                    BgOperationThread = new Thread() {
                                        public void run() {
                                            try {
                                                ShowGDocsProgressMessage("Importing from Google spreadsheet...");

                                                int import_result[] = GDocsOperatorClass.ImportFromGDocs(acct_name, acct_pass,
                                                                                                         sheet_name, GDocsProgressAlert);

                                                if (GDocsOperatorClass.OperationStopped()) {
                                                    ShowInfoMessage("Import was cancelled by user, " +
                                                                    String.valueOf(import_result[0]) + " records imported, " +
                                                                    String.valueOf(import_result[1]) + " errors",
                                                                    GDocsImportForm);
                                                } else {
                                                    ShowInfoMessage("Import complete, " +
                                                                    String.valueOf(import_result[0]) + " records imported, " +
                                                                    String.valueOf(import_result[1]) + " errors",
                                                                    GDocsImportForm);
                                                }
                                            } catch (Exception ex) {
                                                ShowErrorMessage(ex.toString(), GDocsImportForm);
                                            }
                                        }
                                    };

                                    BgOperationThread.start();
                                }
                            } else {
                                ShowErrorMessage("Google spreadsheet name is empty");
                            }
                        } else {
                            ShowErrorMessage("Google account name is empty");
                        }
                    } catch (Exception ex) {
                        ShowErrorMessage(ex.toString());
                    }
                } else if (command == CMD_BACK) {
                    ShowImportList();
                }
            } else if (displayable.equals(CreateInitialBalancesForm)) {
                if (command == CMD_OK) {
                    if (CategoryStorageClass.GetCount() != 0) {
                        ShowSelectInitialBalanceCategoryForm();
                    } else {
                        ShowErrorMessage("No categories defined");
                    }
                } else if (command == CMD_CANCEL) {
                    ShowWalletBalanceTable();
                }
            } else if (displayable.equals(SelectInitialBalanceCategoryForm)) {
                if (command == CMD_OK) {
                    if (SelectInitialBalanceCategoryCategoryChoiceGroup.getSelectedIndex() != -1) {
                        try {
                            SettingStorageClass.SetInitialBalanceCategoryId(SelectInitialBalanceCategoryFormCategoryIds[SelectInitialBalanceCategoryCategoryChoiceGroup.getSelectedIndex()]);

                            Vector wallets = WalletStorageClass.GetListSortedByName();

                            for (int i = 0; i < wallets.size(); i++) {
                                TransactionClass transaction = new TransactionClass(((WalletClass)wallets.elementAt(i)).GetId(),
                                                                                    SelectInitialBalanceCategoryFormCategoryIds[SelectInitialBalanceCategoryCategoryChoiceGroup.getSelectedIndex()],
                                                                                    TransactionStorageClass.GetBalanceForWalletIdMonth(((WalletClass)wallets.elementAt(i)).GetId(),
                                                                                                                                       UtilClass.GetPrevMonth(CurrentMonth)),
                                                                                    new Date(),
                                                                                    "Autocreated initial balance record");

                                if (TransactionStorageClass.Validate(transaction)) {
                                    TransactionStorageClass.Add(transaction);
                                } else {
                                    throw (new Exception(TransactionStorageClass.GetValidateErrorMsg()));
                                }
                            }

                            ShowWalletBalanceTable();
                        } catch (Exception ex) {
                            ShowErrorMessage(ex.toString());
                        }
                    } else {
                        ShowErrorMessage("No category selected");
                    }
                } else if (command == CMD_CANCEL) {
                    ShowWalletBalanceTable();
                }
            }
        }
    }
}
