import java.util.*;

public class WalletBalanceTableClass extends CalendarTableClass {
    private static final String TITLE[]       = {"Wallet", "Balance"};
    private static final int    ALIGN[]       = {CalendarTableClass.ITEM_ALIGN_LEFT,
                                                 CalendarTableClass.ITEM_ALIGN_RIGHT};
    private static final int    FLOAT_COL_NUM = 0;

    private int WalletIds[];

    public WalletBalanceTableClass(Calendar month) {
        super("Wallets", "", month, TITLE, ALIGN, FLOAT_COL_NUM);

        RefreshData();
    }

    protected void RefreshData() {
        Vector wallets;

        SetLabel(UtilClass.GetCalendarMonthName(Month) + " " + String.valueOf(Month.get(Calendar.YEAR)));

        try {
            wallets = WalletStorageClass.GetListSortedByName();

            WalletIds   = new int[wallets.size()];
            Data        = new String[wallets.size()][GetCols()];
            Rows        = Data.length;
            SelectedRow = 0;

            for (int i = 0; i < wallets.size(); i++) {
                WalletClass wallet = (WalletClass)wallets.elementAt(i);

                WalletIds[i] = wallet.GetId();
                Data[i][0]   = wallet.GetName();
                Data[i][1]   = UtilClass.MoneyToString(TransactionStorageClass.GetBalanceForWalletIdMonth(wallet.GetId(), Month));
            }
        } catch (Exception ex) {
            WalletIds   = new int[0];
            Data        = new String[0][GetCols()];
            Rows        = Data.length;
            SelectedRow = 0;
        }
    }

    public int GetWalletId(int selected_index) {
        return WalletIds[selected_index];
    }
}
